#!/bin/sh
# Copyright (C) 2010-2012  CEA/DEN, EDF R&D, OPEN CASCADE
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
# See http://www.salome-platform.org/ or email : webmaster.salome@opencascade.com
#
# Author : Guillaume Boulant (EDF) 
#

#
# This script runs the unit tests embedded in each of the python
# modules of the package salome.kernel.
#
# This script should be executed in a SALOME shell session,
# for example the shell obtained from the command runSession
# provided by the SALOME application.
#

# This first list does not need a SALOME application. Only the
# environnement is required (for example, run these script in a
# session obtained with runSession
listfiles="\
    unittester.py \
    enumerate.py \
    uiexception.py \
    datamodeler.py \
    testdata.py \
    diclookup.py \
    syshelper.py \
    pyunittester.py \
    __init__.py"

# This files should be add to the list
#listfiles=$listfiles"\
#    deprecation.py \
#    logger.py \
#    termcolor.py \
#    logconfig.py"

# This list REQUIRES a running SALOME application
listfiles=$listfiles"\
    services.py \
    studyedit.py"

# This files are not used yet (but we test them)
#listfiles=$listfiles"\
#    salome/kernel/threadhelper.py"

MODULE_ROOT_DIR=/usr
MODULE_PYTHON_DIR=$MODULE_ROOT_DIR/lib/python2.7/site-packages/salome
PYTHONPATH=$MODULE_PYTHON_DIR:$PYTHONPATH
export PYTHONPATH

here=$(pwd)
package_path="salome/kernel"
cd $MODULE_PYTHON_DIR
for file in $listfiles; do
    # Uncomment this line (and comment the next one) to display
    # the start line of a test and not only the result:
    #python $package_path/$file | grep '^\[TEST'
    python $package_path/$file | grep '^\[TEST' | grep -v 'test in progress'
done
cd $here
